diff --git a/app/views/common/_table_generator.html.erb b/app/views/common/_table_generator.html.erb
new file mode 100644
index 000000000..1e2820001
--- /dev/null
+++ b/app/views/common/_table_generator.html.erb
@@ -0,0 +1,14 @@
+<template id="table-generator-template">
+  <table class="table-generator"
+         data-controller="table-generator"
+         data-action="pointerover->table-generator#selectCell pointerdown->table-generator#addMenu pointerdown->table-generator#remove click@window->table-generator#removeWhenOutside"
+         data-alphabets="ABCDEFGHIJ">
+    <% (1..5).each do |r| %>
+      <%= tag.tr do %>
+        <% (1..10).each do |c| %>
+          <%= tag.td data: {row: r, col: c, title: "#{c}&times;#{r}"} %>
+        <% end %>
+      <% end %>
+    <% end %>
+  </table>
+</template>
diff --git a/app/views/common/_texteditor.html.erb b/app/views/common/_texteditor.html.erb
new file mode 100644
index 000000000..41519177b
--- /dev/null
+++ b/app/views/common/_texteditor.html.erb
@@ -0,0 +1,17 @@
+<%= tag.div(class: 'jstBlock', data: { controller: 'texteditor',
+                                       formatting: Setting.text_formatting,
+                                       help: help_wiki_syntax_path,
+                                       texteditor_preview_url_value: preview_url,
+                                       action: 'keydown->texteditor#keyboardShortcuts keydown@window->texteditor#togglePreview' }) do %>
+  <div class="jstTabs tabs" data-texteditor-target="tabs">
+    <ul>
+      <li><%= link_to(nil, '#', class: 'tab-edit selected', data: { texteditor_target: 'edittab', action: 'texteditor#hidePreview' }) %></li>
+      <li><%= link_to(nil, '#', class: 'tab-preview', data: { texteditor_target: 'previewtab', action: 'texteditor#preview texteditor#showPreview' })%></li>
+      <li class="tab-elements"><div class="jstElements" data-texteditor-target="elements" data-action="click->texteditor#execute"></div><li>
+    </ul>
+  </div>
+  <div class="jstEditor" data-texteditor-target="main">
+    <%= yield %>
+    <div class="wiki wiki-preview hidden" data-texteditor-target="preview"></div>
+  </div>
+<% end %>
diff --git a/app/views/documents/_form.html.erb b/app/views/documents/_form.html.erb
index 82dcd9293..97bc96312 100644
--- a/app/views/documents/_form.html.erb
+++ b/app/views/documents/_form.html.erb
@@ -5,10 +5,10 @@
   <p><%= f.text_field :title, :required => true, :size => 60 %></p>
   <p><%= f.text_area :description, :cols => 60, :rows => 15, :class => 'wiki-edit',
                     :data => {
-                        :auto_complete => true
-                    }.merge(list_autofill_data_attributes)
+                        :auto_complete => true,
+                        :wiki_toolbar => Setting.text_formatting.present?
+                    }
                      %></p>
-
   <% @document.custom_field_values.each do |value| %>
     <p><%= custom_field_tag_with_label :document, value %></p>
   <% end %>
@@ -17,5 +17,3 @@
     <p><label><%=l(:label_attachment_plural)%></label><%= render :partial => 'attachments/form', :locals => {:container => @document} %></p>
   <% end %>
 </div>
-
-<%= wikitoolbar_for 'document_description' %>
diff --git a/app/views/issues/_edit.html.erb b/app/views/issues/_edit.html.erb
index 299efec7a..24b968738 100644
--- a/app/views/issues/_edit.html.erb
+++ b/app/views/issues/_edit.html.erb
@@ -29,12 +29,13 @@
     <% end %>
     <% if @issue.notes_addable? %>
       <fieldset id="add_notes"><legend><%= l(:field_notes) %></legend>
-      <%= f.text_area :notes, :cols => 60, :rows => 10, :class => 'wiki-edit',
-            :data => {
-                :auto_complete => true
-            }.merge(list_autofill_data_attributes),
-            :no_label => true %>
-      <%= wikitoolbar_for 'issue_notes', preview_issue_path(:project_id => @project, :issue_id => @issue) %>
+      <%= f.text_area :notes, cols: 60, rows: 10, class: 'wiki-edit',
+            data: {
+                auto_complete: true,
+                wiki_toolbar: Setting.text_formatting.present?,
+                wiki_preview_url: preview_issue_path(project_id: @project, issue_id: @issue)
+            },
+            no_label: true %>
 
       <% if @issue.safe_attribute? 'private_notes' %>
       <%= f.check_box :private_notes, :no_label => true %> <label for="issue_private_notes"><%= l(:field_private_notes) %></label>
diff --git a/app/views/issues/_form.html.erb b/app/views/issues/_form.html.erb
index 4e8e07856..bee1feee3 100644
--- a/app/views/issues/_form.html.erb
+++ b/app/views/issues/_form.html.erb
@@ -32,17 +32,20 @@
 <% if @issue.safe_attribute? 'description' %>
 <p>
   <%= f.label_for_field :description, :required => @issue.required_attribute?('description') %>
-  <%= content_tag 'span', :id => "issue_description_and_toolbar", :style => (@issue.new_record? ? nil : 'display:none') do %>
-    <%= f.text_area :description, :cols => 60, :accesskey => accesskey(:edit), :class => 'wiki-edit',
-                   :rows => [[10, @issue.description.to_s.length / 50].max, 20].min,
-                   :data => {
-                       :auto_complete => true
-                   }.merge(list_autofill_data_attributes),
-                   :no_label => true %>
+  <%= tag.span id: 'issue_description_and_toolbar', style: (@issue.new_record? ? nil : 'display:none'), data: {controller: 'template'} do %>
+    <template data-template-target="element">
+    <%= f.text_area :description, cols: 60, accesskey: accesskey(:edit), class: 'wiki-edit',
+                    rows: [[10, @issue.description.to_s.length / 50].max, 20].min,
+                    data: {
+                      auto_complete: true,
+                      wiki_toolbar: Setting.text_formatting.present?,
+                      wiki_preview_url: preview_issue_path(:project_id => @issue.project, :issue_id => @issue.id)
+                   },
+                   no_label: true %>
+    </template>
   <% end %>
   <%= link_to_function content_tag(:span, sprite_icon('edit', l(:button_edit)), :class => 'icon icon-edit'), '$(this).hide(); $("#issue_description_and_toolbar").show()' unless @issue.new_record? %>
 </p>
-<%= wikitoolbar_for 'issue_description', preview_issue_path(:project_id => @issue.project, :issue_id => @issue.id) %>
 <% end %>
 
 <div id="attributes" class="attributes">
diff --git a/app/views/issues/_form_custom_fields.html.erb b/app/views/issues/_form_custom_fields.html.erb
index fddcd742f..4e62debd4 100644
--- a/app/views/issues/_form_custom_fields.html.erb
+++ b/app/views/issues/_form_custom_fields.html.erb
@@ -19,6 +19,10 @@
 <% end %>
 
 <% custom_field_values_full_width.each do |value| %>
-  <p><%= custom_field_tag_with_label :issue, value, :required => @issue.required_attribute?(value.custom_field_id) %></p>
-  <%= wikitoolbar_for "issue_custom_field_values_#{value.custom_field_id}", preview_issue_path(:project_id => @issue.project, :issue_id => @issue.id) if value.custom_field.full_text_formatting? %>
+  <p>
+    <%= custom_field_tag_with_label :issue, value,
+      required: @issue.required_attribute?(value.custom_field_id),
+      data: { wiki_toolbar: value.custom_field.full_text_formatting?, wiki_preview_url: preview_issue_path(:project_id => @issue.project, :issue_id => @issue.id) }
+    %>
+  </p>
 <% end %>
diff --git a/app/views/issues/bulk_edit.html.erb b/app/views/issues/bulk_edit.html.erb
index 70582b735..e709f57fa 100644
--- a/app/views/issues/bulk_edit.html.erb
+++ b/app/views/issues/bulk_edit.html.erb
@@ -211,9 +211,9 @@
 <% custom_fields_full_width.each do |custom_field| %>
   <p>
     <label><%= custom_field.name %></label>
-    <%= custom_field_tag_for_bulk_edit('issue', custom_field, @issues, @issue_params[:custom_field_values][custom_field.id.to_s]) %>
+    <%= custom_field_tag_for_bulk_edit 'issue', custom_field, @issues, @issue_params[:custom_field_values][custom_field.id.to_s],
+          data: { wiki_toolbar: custom_field.full_text_formatting?, wiki_preview_url: preview_issue_path(project_id: @project, issue_id: nil) } %>
   </p>
-  <%= wikitoolbar_for "issue_custom_field_values_#{custom_field.id}", preview_issue_path(:project_id => @project, :issue_id => nil) if custom_field.full_text_formatting? %>
 <% end %>
 
 </fieldset>
@@ -222,10 +222,10 @@
 <legend><%= l(:field_notes) %></legend>
 <%= text_area_tag 'notes', @notes, :cols => 60, :rows => 10, :class => 'wiki-edit',
                   :data => {
-                      :auto_complete => true
-                  }.merge(list_autofill_data_attributes)
+                      :auto_complete => true,
+                      :wiki_toolbar => Setting.text_formatting.present?
+                  }
 %>
-<%= wikitoolbar_for 'notes' %>
 
 <% if User.current.allowed_to?(:add_issue_watchers, nil, global: true)%>
   <%= update_data_sources_for_auto_complete({users: watchers_autocomplete_for_mention_path(q: '', object_type: 'issue', object_id: @issues.map(&:id) )}) %>
diff --git a/app/views/journals/_notes_form.html.erb b/app/views/journals/_notes_form.html.erb
index 45f20a6c4..244a33eef 100644
--- a/app/views/journals/_notes_form.html.erb
+++ b/app/views/journals/_notes_form.html.erb
@@ -6,8 +6,10 @@
     <%= text_area_tag 'journal[notes]', @journal.notes, :id => "journal_#{@journal.id}_notes", :class => 'wiki-edit',
           :rows => (@journal.notes.blank? ? 10 : [[10, @journal.notes.length / 50].max, 100].min),
           :data => {
-              :auto_complete => true
-          }.merge(list_autofill_data_attributes)
+              :auto_complete => true,
+              :wiki_toolbar => Setting.text_formatting.present?,
+              :wiki_preview_url => preview_issue_path(project_id: @project, issue_id: @journal.issue)
+          }
     %>
     <% if @journal.safe_attribute? 'private_notes' %>
       <%= hidden_field_tag 'journal[private_notes]', '0' %>
@@ -18,4 +20,3 @@
     <p><%= submit_tag l(:button_save) %>
     <%= link_to l(:button_cancel), '#', :onclick => "$('#journal-#{@journal.id}-form').remove(); $('#journal-#{@journal.id}-notes').show(); return false;" %></p>
 <% end %>
-<%= wikitoolbar_for "journal_#{@journal.id}_notes", preview_issue_path(:project_id => @project, :issue_id => @journal.issue) %>
diff --git a/app/views/messages/_form.html.erb b/app/views/messages/_form.html.erb
index 492390036..c738b4e4e 100644
--- a/app/views/messages/_form.html.erb
+++ b/app/views/messages/_form.html.erb
@@ -26,10 +26,11 @@
 <%= f.text_area :content, :cols => 80, :rows => 15, :class => 'wiki-edit', :id => 'message_content',
                 :accesskey => accesskey(:edit),
                 :data => {
-                    :auto_complete => true
-                }.merge(list_autofill_data_attributes)
+                    :auto_complete => true,
+                    :wiki_toolbar => Setting.text_formatting.present?,
+                    :wiki_preview_url => preview_board_message_path(:board_id => @board, :id => @message)
+                }
 %></p>
-<%= wikitoolbar_for 'message_content', preview_board_message_path(:board_id => @board, :id => @message) %>
 <!--[eoform:message]-->
 
 <p><%= l(:label_attachment_plural) %><br />
diff --git a/app/views/news/_form.html.erb b/app/views/news/_form.html.erb
index f86bba176..12a66b838 100644
--- a/app/views/news/_form.html.erb
+++ b/app/views/news/_form.html.erb
@@ -12,10 +12,10 @@
 <p><%= f.text_area :summary, :cols => 60, :rows => 2 %></p>
 <p><%= f.text_area :description, :required => true, :cols => 60, :rows => 15, :class => 'wiki-edit',
                    :data => {
-                       :auto_complete => true
-                   }.merge(list_autofill_data_attributes)
+                       :auto_complete => true,
+                       :wiki_toolbar => Setting.text_formatting.present?,
+                       :wiki_preview_url => preview_news_path(:project_id => @project, :id => @news)
+                   }
 %></p>
 <p id="attachments_form"><label><%= l(:label_attachment_plural) %></label><%= render :partial => 'attachments/form', :locals => {:container => @news} %></p>
 </div>
-
-<%= wikitoolbar_for 'news_description', preview_news_path(:project_id => @project, :id => @news) %>
diff --git a/app/views/news/show.html.erb b/app/views/news/show.html.erb
index 11126998e..c8517f924 100644
--- a/app/views/news/show.html.erb
+++ b/app/views/news/show.html.erb
@@ -67,12 +67,13 @@
 <p><%= toggle_link l(:label_comment_add), "add_comment_form", :focus => "comment_comments" %></p>
 <%= form_tag({:controller => 'comments', :action => 'create', :id => @news}, :id => "add_comment_form", :style => "display:none;") do %>
 <div class="box">
-    <%= text_area 'comment', 'comments', :cols => 80, :rows => 15, :class => 'wiki-edit',
+    <%= text_area_tag 'comment', nil, :cols => 80, :rows => 15, :class => 'wiki-edit',
                   :data => {
-                    :auto_complete => true
-                  }.merge(list_autofill_data_attributes)
+                    :auto_complete => true,
+                    :wiki_toolbar => Setting.text_formatting.present?,
+                    :wiki_preview_url => preview_news_path(:project_id => @project, :id => @news)
+                  }
     %>
-    <%= wikitoolbar_for 'comment_comments', preview_news_path(:project_id => @project, :id => @news) %>
 </div>
 <p><%= submit_tag l(:button_add) %></p>
 <% end %>
diff --git a/app/views/projects/_form.html.erb b/app/views/projects/_form.html.erb
index 0f8733e28..66dedb6b2 100644
--- a/app/views/projects/_form.html.erb
+++ b/app/views/projects/_form.html.erb
@@ -4,7 +4,7 @@
 <!--[form:project]-->
 <p><%= f.text_field :name, :required => true, :size => 60 %></p>
 
-<p><%= f.text_area :description, :rows => 8, :class => 'wiki-edit', :data => list_autofill_data_attributes %></p>
+<p><%= f.text_area :description, :rows => 8, :class => 'wiki-edit', :data => { :wiki_toolbar => Setting.text_formatting.present? } %></p>
 <p><%= f.text_field :identifier, :required => true, :size => 60, :disabled => @project.identifier_frozen?, :maxlength => Project::IDENTIFIER_MAX_LENGTH %>
 <% unless @project.identifier_frozen? %>
   <em class="info"><%= l(:text_length_between, :min => 1, :max => Project::IDENTIFIER_MAX_LENGTH) %> <%= l(:text_project_identifier_info).html_safe %></em>
@@ -23,8 +23,6 @@
 <p><%= f.check_box :inherit_members %></p>
 <% end %>
 
-<%= wikitoolbar_for 'project_description' %>
-
 <% @project.visible_custom_field_values.each do |value| %>
   <p><%= custom_field_tag_with_label :project, value %></p>
 <% end %>
diff --git a/app/views/search/index.html.erb b/app/views/search/index.html.erb
index b092bbae0..c17bbd8ea 100644
--- a/app/views/search/index.html.erb
+++ b/app/views/search/index.html.erb
@@ -6,7 +6,7 @@
 <p><%= text_field_tag 'q', @question, :size => 60, :id => 'search-input',
                       :data => {
                           :auto_complete => true
-                      }.merge(list_autofill_data_attributes) %>
+                      } %>
 <%= project_select_tag %>
 <%= hidden_field_tag 'all_words', '', :id => nil %>
 <label><%= check_box_tag 'all_words', 1, @all_words %> <%= l(:label_all_words) %></label>
diff --git a/app/views/settings/_general.html.erb b/app/views/settings/_general.html.erb
index 5afd1cb44..2e1ab42a6 100644
--- a/app/views/settings/_general.html.erb
+++ b/app/views/settings/_general.html.erb
@@ -3,9 +3,7 @@
 <div class="box tabular settings">
 <p><%= setting_text_field :app_title, :size => 30 %></p>
 
-<p><%= setting_text_area :welcome_text, :cols => 60, :rows => 5, :class => 'wiki-edit', :data => list_autofill_data_attributes %></p>
-<%= wikitoolbar_for 'settings_welcome_text' %>
-
+<p><%= setting_text_area :welcome_text, :cols => 60, :rows => 5, :class => 'wiki-edit', :data => { :wiki_toolbar => Setting.text_formatting.present? } %></p>
 
 <p><%= setting_text_field :per_page_options, :size => 20 %>
 <em class="info"><%= l(:text_comma_separated) %></em></p>
diff --git a/app/views/settings/_notifications.html.erb b/app/views/settings/_notifications.html.erb
index 9856d4fec..2514730f0 100644
--- a/app/views/settings/_notifications.html.erb
+++ b/app/views/settings/_notifications.html.erb
@@ -19,13 +19,11 @@
 </fieldset>
 
 <fieldset class="box"><legend><%= l(:setting_emails_header) %></legend>
-<%= setting_text_area :emails_header, :label => false, :class => 'wiki-edit', :rows => 5, :data => list_autofill_data_attributes %>
-<%= wikitoolbar_for 'settings_emails_header' %>
+<%= setting_text_area :emails_header, :label => false, :class => 'wiki-edit', :rows => 5, :data => { :wiki_toolbar => Setting.text_formatting.present? } %>
 </fieldset>
 
 <fieldset class="box"><legend><%= l(:setting_emails_footer) %></legend>
-<%= setting_text_area :emails_footer, :label => false, :class => 'wiki-edit', :rows => 5, :data => list_autofill_data_attributes %>
-<%= wikitoolbar_for 'settings_emails_footer' %>
+<%= setting_text_area :emails_footer, :label => false, :class => 'wiki-edit', :rows => 5, :data => { :wiki_toolbar => Setting.text_formatting.present? } %>
 </fieldset>
 
 <div style="float:right;">
diff --git a/app/views/timelog/_form.html.erb b/app/views/timelog/_form.html.erb
index 3a0543e7c..19d833abe 100644
--- a/app/views/timelog/_form.html.erb
+++ b/app/views/timelog/_form.html.erb
@@ -30,10 +30,8 @@
   <p><%= f.text_field :comments, :size => 100, :maxlength => 1024, :required => Setting.timelog_required_fields.include?('comments') %></p>
   <p><%= f.select :activity_id, activity_collection_for_select_options(@time_entry), :required => true %></p>
   <% @time_entry.editable_custom_field_values.each do |value| %>
-    <p><%= custom_field_tag_with_label :time_entry, value %></p>
-    <% if value.custom_field.full_text_formatting? %>
-      <%= wikitoolbar_for "time_entry_custom_field_values_#{value.custom_field_id}", preview_issue_path(:project_id => @project) %>
-    <% end %>
+    <p><%= custom_field_tag_with_label :time_entry, value,
+             data: { wiki_toolbar: value.custom_field.full_text_formatting?, wiki_preview_url: preview_issue_path(project_id: @project) } %></p>
   <% end %>
   <%= call_hook(:view_timelog_edit_form_bottom, { :time_entry => @time_entry, :form => f }) %>
 </div>
diff --git a/app/views/timelog/bulk_edit.html.erb b/app/views/timelog/bulk_edit.html.erb
index 4f496470a..32bbd5c45 100644
--- a/app/views/timelog/bulk_edit.html.erb
+++ b/app/views/timelog/bulk_edit.html.erb
@@ -71,9 +71,9 @@
     <% @custom_fields.each do |custom_field| %>
       <p>
         <label><%= h(custom_field.name) %></label>
-        <%= custom_field_tag_for_bulk_edit('time_entry', custom_field, @time_entries, @time_entry_params[:custom_field_values][custom_field.id.to_s]) %>
+        <%= custom_field_tag_for_bulk_edit 'time_entry', custom_field, @time_entries, @time_entry_params[:custom_field_values][custom_field.id.to_s],
+              data: { wiki_toolbar: custom_field.full_text_formatting?, wiki_preview_url: preview_issue_path(:project_id => @project) } %>
       </p>
-      <%= wikitoolbar_for "time_entry_custom_field_values_#{custom_field.id}", preview_issue_path(:project_id => @project) if custom_field.full_text_formatting? %>
     <% end %>
 
     <%= call_hook(:view_time_entries_bulk_edit_details_bottom, { :time_entries => @time_entries }) %>
diff --git a/app/views/wiki/edit.html.erb b/app/views/wiki/edit.html.erb
index 115b5b2c4..eaceb161a 100644
--- a/app/views/wiki/edit.html.erb
+++ b/app/views/wiki/edit.html.erb
@@ -16,8 +16,10 @@
 <%= text_area_tag 'content[text]', @text, :cols => 100, :rows => 25, :accesskey => accesskey(:edit),
                   :class => 'wiki-edit',
                   :data => {
-                      :auto_complete => true
-                  }.merge(list_autofill_data_attributes)
+                      :auto_complete => true,
+                      :wiki_toolbar => Setting.text_formatting.present?,
+                      :wiki_preview_url => preview_project_wiki_page_path(project_id: @project, id: @page.title)
+                  }
 %>
 
 <% if @page.safe_attribute_names.include?('parent_id') && @wiki.pages.any? %>
@@ -64,7 +66,6 @@
   <%= submit_tag l(:button_save) %>
   <%= link_to l(:button_cancel), wiki_page_edit_cancel_path(@page) %>
  </p>
-<%= wikitoolbar_for 'content_text', preview_project_wiki_page_path(:project_id => @project, :id => @page.title) %>
 
 <% if User.current.allowed_to?(:add_wiki_page_watchers, @project)%>
   <%= update_data_sources_for_auto_complete({users: watchers_autocomplete_for_mention_path(project_id: @project, q: '', object_type: 'wiki_page', object_id: @page.id)}) %>
diff --git a/config/importmap.rb b/config/importmap.rb
index 3560330c1..2314e905c 100644
--- a/config/importmap.rb
+++ b/config/importmap.rb
@@ -3,6 +3,10 @@
 # Pin npm packages by running ./bin/importmap
 
 pin "application"
+pin "helper"
+pin "jstoolbar", preload: false
+pin_all_from "app/javascript/jstoolbar/formatting", under: "jstoolbar/formatting", preload: false
+
 pin "@hotwired/stimulus", to: "stimulus.min.js"
 pin "@hotwired/stimulus-loading", to: "stimulus-loading.js"
 pin "turndown" # @7.2.0
diff --git a/lib/redmine/views/labelled_form_builder.rb b/lib/redmine/views/labelled_form_builder.rb
index f364ca8e2..ecf199dd7 100644
--- a/lib/redmine/views/labelled_form_builder.rb
+++ b/lib/redmine/views/labelled_form_builder.rb
@@ -65,4 +65,16 @@ class Redmine::Views::LabelledFormBuilder < ActionView::Helpers::FormBuilder
                           :class => (@object && @object.errors[field].present? ? "error" : nil),
                           :for => (@object_name.to_s + "_" + field.to_s))
   end
+
+  def text_area(method, options={})
+    data = options[:data] || {}
+    wiki_toolbar = data.delete(:wiki_toolbar)
+    if wiki_toolbar
+      @template.add_wiki_toolbar(data) do
+        text_area(method, options)
+      end
+    else
+      super
+    end
+  end
 end
diff --git a/lib/redmine/wiki_formatting.rb b/lib/redmine/wiki_formatting.rb
index ce6097646..29e478842 100644
--- a/lib/redmine/wiki_formatting.rb
+++ b/lib/redmine/wiki_formatting.rb
@@ -89,7 +89,7 @@ module Redmine
       def to_html(format, text, options = {})
         text =
           if Setting.cache_formatted_text? && text.size > 2.kilobytes && cache_store &&
-              cache_key = cache_key_for(format, text, options[:object], options[:attribute])
+            cache_key = cache_key_for(format, text, options[:object], options[:attribute])
             # Text retrieved from the cache store may be frozen
             # We need to dup it so we can do in-place substitutions with gsub!
             cache_store.fetch cache_key do
@@ -141,12 +141,6 @@ module Redmine
       end
 
       module Helper
-        def wikitoolbar_for(field_id, preview_url = preview_text_path)
-        end
-
-        def heads_for_wiki_formatter
-        end
-
         def initial_page_content(page)
           page.pretty_title.to_s
         end
diff --git a/lib/redmine/wiki_formatting/common_mark/helper.rb b/lib/redmine/wiki_formatting/common_mark/helper.rb
index f75f1fc0e..a597afa39 100644
--- a/lib/redmine/wiki_formatting/common_mark/helper.rb
+++ b/lib/redmine/wiki_formatting/common_mark/helper.rb
@@ -21,43 +21,9 @@ module Redmine
   module WikiFormatting
     module CommonMark
       module Helper
-        def wikitoolbar_for(field_id, preview_url = preview_text_path)
-          heads_for_wiki_formatter
-
-          javascript_tag(
-            "var wikiToolbar = new jsToolBar(document.getElementById('#{field_id}')); " \
-            "wikiToolbar.setHelpLink('#{escape_javascript help_wiki_syntax_path}'); " \
-            "wikiToolbar.setPreviewUrl('#{escape_javascript preview_url}'); " \
-            "wikiToolbar.draw();"
-          )
-        end
-
         def initial_page_content(page)
           "# #{page.pretty_title}"
         end
-
-        def heads_for_wiki_formatter
-          unless @heads_for_wiki_formatter_included
-            toolbar_language_options = User.current && User.current.pref.toolbar_language_options
-            lang =
-              if toolbar_language_options.nil?
-                UserPreference::DEFAULT_TOOLBAR_LANGUAGE_OPTIONS
-              else
-                toolbar_language_options.split(',')
-              end
-            content_for :header_tags do
-              javascript_include_tag('jstoolbar/jstoolbar') +
-              javascript_include_tag('jstoolbar/common_mark') +
-              javascript_include_tag("jstoolbar/lang/jstoolbar-#{current_language.to_s.downcase}") +
-              javascript_tag(
-                "var wikiImageMimeTypes = #{Redmine::MimeType.by_type('image').to_json};" \
-                  "var userHlLanguages = #{lang.to_json};"
-              ) +
-              stylesheet_link_tag('jstoolbar')
-            end
-            @heads_for_wiki_formatter_included = true
-          end
-        end
       end
     end
   end
diff --git a/lib/redmine/wiki_formatting/textile/helper.rb b/lib/redmine/wiki_formatting/textile/helper.rb
index ad6e53992..5f01115b8 100644
--- a/lib/redmine/wiki_formatting/textile/helper.rb
+++ b/lib/redmine/wiki_formatting/textile/helper.rb
@@ -21,41 +21,9 @@ module Redmine
   module WikiFormatting
     module Textile
       module Helper
-        def wikitoolbar_for(field_id, preview_url = preview_text_path)
-          heads_for_wiki_formatter
-
-          javascript_tag(
-            "var wikiToolbar = new jsToolBar(document.getElementById('#{field_id}')); " \
-              "wikiToolbar.setHelpLink('#{escape_javascript help_wiki_syntax_path}'); " \
-              "wikiToolbar.setPreviewUrl('#{escape_javascript preview_url}'); wikiToolbar.draw();"
-          )
-        end
-
         def initial_page_content(page)
           "h1. #{page.pretty_title}"
         end
-
-        def heads_for_wiki_formatter
-          unless @heads_for_wiki_formatter_included
-            toolbar_language_options = User.current && User.current.pref.toolbar_language_options
-            lang =
-              if toolbar_language_options.nil?
-                UserPreference::DEFAULT_TOOLBAR_LANGUAGE_OPTIONS
-              else
-                toolbar_language_options.split(',')
-              end
-            content_for :header_tags do
-              javascript_include_tag('jstoolbar/jstoolbar') +
-              javascript_include_tag('jstoolbar/textile') +
-              javascript_include_tag("jstoolbar/lang/jstoolbar-#{current_language.to_s.downcase}") +
-              javascript_tag(
-                "var wikiImageMimeTypes = #{Redmine::MimeType.by_type('image').to_json};" \
-                  "var userHlLanguages = #{lang.to_json};") +
-              stylesheet_link_tag('jstoolbar')
-            end
-            @heads_for_wiki_formatter_included = true
-          end
-        end
       end
     end
   end
diff --git a/test/helpers/application_helper_test.rb b/test/helpers/application_helper_test.rb
index aad2c4542..749ae2026 100644
--- a/test/helpers/application_helper_test.rb
+++ b/test/helpers/application_helper_test.rb
@@ -2397,6 +2397,20 @@ class ApplicationHelperTest < Redmine::HelperTest
     assert_equal '', result
   end
 
+  def test_text_area_with_text_formatting
+    with_settings :text_formatting => 'textile' do
+      element = text_area_tag 'sample', '', data: {wiki_toolbar: Setting.text_formatting.present?}
+      assert_match 'texteditor', element
+    end
+  end
+
+  def test_text_area_without_text_formatting
+    with_settings :text_formatting => '' do
+      element = text_area_tag 'sample', '', data: {wiki_toolbar: Setting.text_formatting.present?}
+      assert_no_match 'texteditor', element
+    end
+  end
+
   private
 
   def wiki_links_with_special_characters
@@ -2427,23 +2441,4 @@ class ApplicationHelperTest < Redmine::HelperTest
                   :class => "wiki-page new"),
     }
   end
-
-  def test_list_autofill_data_attributes
-    with_settings :text_formatting => 'textile' do
-      expected = {
-        controller: "list-autofill",
-        action: "keydown->list-autofill#handleEnter",
-        list_autofill_target: "input",
-        list_autofill_text_formatting_param: "textile"
-      }
-
-      assert_equal expected, list_autofill_data_attributes
-    end
-  end
-
-  def test_list_autofill_data_attributes_with_blank_text_formatting
-    with_settings :text_formatting => '' do
-      assert_equal({}, list_autofill_data_attributes)
-    end
-  end
 end
diff --git a/test/integration/layout_test.rb b/test/integration/layout_test.rb
index a1c918ae0..3132396d0 100644
--- a/test/integration/layout_test.rb
+++ b/test/integration/layout_test.rb
@@ -57,8 +57,11 @@ class LayoutTest < Redmine::IntegrationTest
     Role.anonymous.add_permission! :add_issues
 
     get '/projects/ecookbook/issues/new'
-    assert_select "head script:match('src',?)", %r{/assets/jstoolbar/jstoolbar-\w+.js}
-    assert_include "var userHlLanguages = #{UserPreference::DEFAULT_TOOLBAR_LANGUAGE_OPTIONS.to_json};", response.body
+
+    text = Nokogiri::HTML5.fragment(response.body).css('script[type=importmap]').text
+    importmap = JSON.parse(text)
+    assert_match /jstoolbar-\w+/, importmap['imports']['jstoolbar']
+    assert_select 'template#code-highlighting-template'
   end
 
   def test_calendar_header_tags
-- 
2.39.5

